%bcond_without check
%global rustflags_debuginfo 1

Summary:        Helper program to build and install c-like libraries
Name:           cargo-c
Version:        0.9.18
Release:        8t%{?dist}
License:        MIT
URL:            https://crates.io/crates/cargo-c
Source0:        https://github.com/lu-zero/cargo-c/archive/refs/tags/v%{version}.tar.gz #/%{name}-%{version}.tar.gz
# cd source directory; cargo vendor; tar
Source1:        vendor.tar.gz
Patch3001:      0001-cargo-c-0.9.18-add-support-for-loongarch64.patch
Patch5000:      fix-time-E0282-build-error.patch

BuildRequires:  cargo < 1.78 rust-toolset
BuildRequires:  pkgconfig(openssl)

%description
cargo applet to build and install C-ABI compatible dynamic and static libraries.
It produces and installs a correct pkg-config file, a static library and
a dynamic library, and a C header to be used by any C (and C-compatible) software.


%prep
%setup
%cargo_prep -V 1
%patch 3001 -p1
%patch 5000 -p1


%build
%cargo_build


%install
%cargo_install


%if %{with check}
%check
%cargo_test
%endif


%files
%license LICENSE
%doc README.md
%{_bindir}/cargo-capi
%{_bindir}/cargo-cbuild
%{_bindir}/cargo-cinstall
%{_bindir}/cargo-ctest


%changelog
* Mon Sep 2 2024 Upgrade Robot <upbot@opencloudos.tech> - 0.9.18-8
- fix E0282 build error in vendor 'time'
- add shell script for rpm-upgrade

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.18-7
- Rebuilt for loongarch release

* Wed Jun 5 2024 Pengda Dou <doupengda@loongson.cn> - 0.9.18-6
- [Type] other
- [DESC] add support for loongarch64

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.18-5
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Jul 18 2023 Wang Guodong <gordonwwang@tencent.com> - 0.9.18-4
- Rebuilt for rust 1.69.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.18-3
- Rebuilt for OpenCloudOS Stream 23.05

* Thu Apr 27 2023 rockerzhu <rockerzhu@tencent.com> - 0.9.18-2
- Enable check.

* Sun Apr 23 2023 rockerzhu <rockerzhu@tencent.com> - 0.9.18-1
- Initial build.
